'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _curry = require('ramda/src/curry');

var _curry2 = _interopRequireDefault(_curry);

var _assoc = require('ramda/src/assoc');

var _assoc2 = _interopRequireDefault(_assoc);

var _prop = require('ramda/src/prop');

var _prop2 = _interopRequireDefault(_prop);

var _assocPath = require('ramda/src/assocPath');

var _assocPath2 = _interopRequireDefault(_assocPath);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _isValid = require('../utils/isValid');

var _isValid2 = _interopRequireDefault(_isValid);

var _createErrorComponent = require('./createErrorComponent');

var _createErrorComponent2 = _interopRequireDefault(_createErrorComponent);

var _createValidation = require('../createValidation');

var _createValidation2 = _interopRequireDefault(_createValidation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// default ErrorComponent
var DefaultErrorComponent = function DefaultErrorComponent(_ref) {
  var errorMsg = _ref.errorMsg;
  return _react2.default.createElement(
    'div',
    { className: 'error' },
    errorMsg
  );
};

function Revalidation(initialState, validationRules, errorComponent, options, Component) {

  var _validate = (0, _createValidation2.default)((0, _createErrorComponent2.default)(errorComponent || DefaultErrorComponent));

  return function (_React$Component) {
    _inherits(_class, _React$Component);

    function _class(props) {
      _classCallCheck(this, _class);

      var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props));

      _this.validateSingle = options ? options.validateSingle : false;
      _this.state = { form: props.form || initialState, errors: {} };
      _this.validate = _this.validate.bind(_this);
      _this.validateAll = _this.validateAll.bind(_this);
      return _this;
    }

    _createClass(_class, [{
      key: 'validate',
      value: function validate(name) {
        var _this2 = this;

        return function (value) {
          return _this2.setState(function (state) {
            var updatedState = (0, _assocPath2.default)(['form', name], value, state);
            var errors = _validate((0, _prop2.default)('form', updatedState), validationRules);
            if (_this2.validateSingle) {
              return (0, _assocPath2.default)(['errors', name], errors[name], updatedState);
            }
            return (0, _assoc2.default)('errors', errors, updatedState);
          });
        };
      }
    }, {
      key: 'validateAll',
      value: function validateAll(cb, form) {
        var _this3 = this;

        this.setState(function (state) {
          var errors = _validate((0, _prop2.default)('form', state), validationRules);
          return (0, _assoc2.default)('errors', errors, state);
        }, function () {
          if ((0, _isValid2.default)(_this3.state.errors)) cb(form || _this3.state.form);
        });
      }
    }, {
      key: 'render',
      value: function render() {
        var _state = this.state,
            form = _state.form,
            errors = _state.errors;

        var valid = (0, _isValid2.default)(_validate(form, validationRules));

        var reValidation = {
          form: form,
          errors: errors,
          valid: valid,
          validate: this.validate,
          validateAll: this.validateAll
        };

        return _react2.default.createElement(Component, _extends({}, this.props, {
          reValidation: reValidation
        }));
      }
    }]);

    return _class;
  }(_react2.default.Component);
}

exports.default = (0, _curry2.default)(Revalidation);